/*
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
*/

class DummyAlarmanlageController implements AlarmanlageControllerInterface {
    def views = [:]
    def observers = [:]

    DummyAlarmanlageStatus status = new DummyAlarmanlageStatus()

    def addView(String name, AlarmanlageViewInterface view) {
        if (name == "DummyStatusanzeige") {
            view.addStatusModel(this.status)
            view.addAlarmModel(this.status)
        }
        if (name == "StatusLed") {
            view.addStatusModel(this.status)
        }
        this.views.put(name, view)
    }

    def addObserver(String name, AlarmanlageObserverInterface model) {
        this.observers.put(name, model)
    }

    def event(name, value) {
        if (name == "active" || name == "sensor") {
            status.event(name, value);
            this.views.each{ entry ->
                entry.value.refresh()
            }
        }
    }

    def run() {
        while (true) {
            this.observers.each{ entry ->
                entry.value.doAction()
            }
            this.views.each{ entry ->
                entry.value.doAction()
            }
        }
    }
}